//+------------------------------------------------------------------+
//|                                                        FRAMA.mq4 |
//|                                                             Rosh |
//|                    http://www.alpari-idc.ru/ru/experts/articles/ |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  DeepSkyBlue
#property indicator_color2  LimeGreen
#property indicator_color3  LimeGreen
#property indicator_color4  Red
#property indicator_color5  Red
#property indicator_color6  DimGray
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_width1  2

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern int    PeriodFRAMA             = 10;
extern int    PriceType               = 0;
extern bool   ShowMiddleLine          = true;
extern int    DzLookBackBars          = 50;
extern double DzStartBuyProbability1  = 0.10;
extern double DzStartBuyProbability2  = 0.25;
extern double DzStartSellProbability1 = 0.10;
extern double DzStartSellProbability2 = 0.25;

//
//
//
//
//

double Buffer1[];
double bl1Buffer[];
double bl2Buffer[];
double sl1Buffer[];
double sl2Buffer[];
double zliBuffer[];

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,bl1Buffer); 
   SetIndexBuffer(2,bl2Buffer); 
   SetIndexBuffer(3,sl2Buffer); 
   SetIndexBuffer(4,sl1Buffer); 
   SetIndexBuffer(5,zliBuffer);
 
   return(0);
  }
  
//  
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//                             
//

int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      double Hi1 = High[iHighest(Symbol(),0,MODE_HIGH,PeriodFRAMA,i)];
      double Lo1 = Low[iLowest(Symbol(),  0,MODE_LOW, PeriodFRAMA,i)];
      double Hi2 = High[iHighest(Symbol(),0,MODE_HIGH,PeriodFRAMA,i+PeriodFRAMA)];
      double Lo2 = Low[iLowest(Symbol(),  0,MODE_LOW, PeriodFRAMA,i+PeriodFRAMA)];
      double Hi3 = High[iHighest(Symbol(),0,MODE_HIGH,2*PeriodFRAMA,i)];
      double Lo3 = Low[iLowest(Symbol(),  0,MODE_LOW, 2*PeriodFRAMA,i)];
      double N1  = (Hi1-Lo1)/PeriodFRAMA;
      double N2  = (Hi2-Lo2)/PeriodFRAMA;
      double N3  = (Hi3-Lo3)/(2.0*PeriodFRAMA);
      double D   = (MathLog(N1+N2)-MathLog(N3))/MathLog(2.0);
      double ALFA= MathExp(-4.6*(D-1.0));
      
      Buffer1[i]=ALFA*Price(i)+(1-ALFA)*Buffer1[i+1];
      if (DzStartBuyProbability1 >0) bl1Buffer[i] = dzBuyP (Buffer1, DzStartBuyProbability1,  DzLookBackBars, Bars, i, 0.0001);
      if (DzStartBuyProbability2 >0) bl2Buffer[i] = dzBuyP (Buffer1, DzStartBuyProbability2,  DzLookBackBars, Bars, i, 0.0001);
      if (DzStartSellProbability1>0) sl1Buffer[i] = dzSellP(Buffer1, DzStartSellProbability1, DzLookBackBars, Bars, i, 0.0001);
      if (DzStartSellProbability2>0) sl2Buffer[i] = dzSellP(Buffer1, DzStartSellProbability2, DzLookBackBars, Bars, i, 0.0001);
      if (ShowMiddleLine)            zliBuffer[i] = dzSellP(Buffer1, 0.5                    , DzLookBackBars, Bars, i, 0.0001);
      
      }

   return(0);
  }
  
//+------------------------------------------------------------------+
//
//
//
//

double Price(int shift)
  {
//----
   double res;
//----
   switch (PriceType)
      {
      case PRICE_OPEN: res=Open[shift]; break;
      case PRICE_HIGH: res=High[shift]; break;
      case PRICE_LOW: res=Low[shift]; break;
      case PRICE_MEDIAN: res=(High[shift]+Low[shift])/2.0; break;
      case PRICE_TYPICAL: res=(High[shift]+Low[shift]+Close[shift])/3.0; break;
      case PRICE_WEIGHTED: res=(High[shift]+Low[shift]+2*Close[shift])/4.0; break;
      default: res=Close[shift];break;
      }
   return(res);
  }

